/* Created by Anjuta version 1.2.4a */
/*	This file will not be overwritten */

/*
 * binay-recursive.c
 * Written by ST. Kim
 */

#include <stdio.h>
#include <time.h>

 
int recursive_count = 0;	// 재귀호출 카운트를 위한 전역 변수

/* name : binsearch
 * discription : find the index, by binary search
 */
void binsearch(int start, int end, const int *S, int x, int *location) {
	
	int low, high, mid;
	
	low = start;
	high = end;

	*location = 0;
	while (low <= high && *location == 0) {
		
		recursive_count++;
		printf("현재 %d번째의 루프를 수행중입니다.\n", recursive_count);
		mid = (low + high) / 2;
		if (x == S[mid])
			*location = mid;
		else if (x < S[mid]) {
			high = mid - 1;
			binsearch(low, high, S, x, location);
		}
		else {
			low = mid + 1;
			binsearch(low, high, S, x, location);
		}
	}
}
	
int main()
{
	struct timespec tv1, tv2;	// 시간측정을 위한 timespec struct. 아래에 struct 내용이 나와있음.
	/*
	struct timespec {
		time_t   tv_sec;        // seconds
		long     tv_nsec;       // nanoseconds
 	};
 	*/
	int i, size, searnum, index, time_check;
	
	printf("지금부터 이진검색 알고리즘을 실행합니다.\n\n\n\n");
	printf("원하시는 배열의 크기를 입력해 주세요.\n");
	printf("배열의 크기 : ");
	scanf("%d", &size);
	size += 1;
	
	int S[size];
	
	for (i = 0; i < size; i++) {
		S[i] = i;
	}
	
	printf("\n찾고자 하시는 숫자를 입력해주세요.\n");
	printf("숫자 입력! : ");
	scanf("%d", &searnum);
	
	printf("\n잠시만 기다려 주세요....\n\n\n");

	time_check = clock_gettime(CLOCK_REALTIME, &tv1);	// time-stamp tv1
	
	binsearch(0, size, S, searnum, &index);
	
	printf("\n\n찾았습니다!!!\n");
	printf("배열의 인덱스의 위치는 %d 입니다.\n\n", index);
	
	time_check = clock_gettime(CLOCK_REALTIME, &tv2);	// time-stamp tv2
	printf("재귀적 함수 실행 시간입니다.\n\n실행시간 : %ds, %ldns\n", tv2.tv_sec - tv1.tv_sec, (tv2.tv_nsec - tv1.tv_nsec));	
	
	return (0);
}
